<?php
/**
 * Implements hook_form().
 */
function scald_file_validators_config_form($form, &$form_state) {

    $scald_types = array('video', 'audio', 'image', 'file');

    foreach ($scald_types as $type) {
        $form[$type] = array(
            '#type' => 'fieldset',
            '#title' => t(ucwords($type)),
            '#collapsible' => FALSE,
            '#collapsed' => FALSE,
        );
        $form[$type]['scald_file_validators_maximum_size_'.$type] = array(
            '#type' => 'textfield',
            '#title' => t('Maximum size'),
            '#default_value' => variable_get('scald_file_validators_maximum_size_'.$type, NULL),
            '#size' => 60,
            '#description' => t('An integer specifying the maximum file size in megabytes. Zero indicates that no limit should be enforced.'),
            '#required' => FALSE,
            '#element_validate' => array('scald_file_validators_maximum_size_validate'),
        );
        $form[$type]['scald_file_validators_extensions_'.$type] = array(
            '#type' => 'textfield',
            '#title' => t('Allowed extensions'),
            '#default_value' => variable_get('scald_file_validators_extensions_'.$type, NULL),
            '#size' => 60,
            '#description' => t('A string with a space separated list of allowed extensions.'),
            '#required' => FALSE,
        );
    }

    return system_settings_form($form);
}

/**
 * Custom form validators
 */
function scald_file_validators_maximum_size_validate($element, $form_state) {
    $maximum_size = $form_state['values'][$element['#name']];
    if ($maximum_size != NULL && !is_numeric($maximum_size)) {
        form_error($element, t('Maximum file size must be a integer.'));
    }
}
